/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 16/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.JenisRange;
import com.portofolio.entity.vo.JenisRangeId;

@Lazy
@Repository
public interface JenisRangeDao extends CrudRepository<JenisRange, JenisRangeId> {

	@Cacheable("JenisRangeDaofindOneBy")
	JenisRange findOneByIdKodeAndIdKdProfileAndKdDepartemen(Integer kode, Integer kdProfile, String KdDepartemen);
	
	JenisRange findOneByIdKodeAndIdKdProfile(Integer kode, Integer kdProfile);

	@Query(QListAll + " and model.namaJenisRange like %:namaJenisRange% ")//and model.kdJenisRangeHead is null ")
	@Cacheable("JenisRangeDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaJenisRange") String namaJenisRange, Pageable page, @Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.namaJenisRange like %:namaJenisRange% and model.kdJenisRangeHead=:kdJenisRangeHead ")
	@Cacheable("JenisRangeDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("namaJenisRange") String namaJenisRange, Pageable page, @Param("kdDepartemen") String kdDepartemen,
			@Param("kdJenisRangeHead") Integer kdJenisRangeHead);

	@Query(QListAll + " and model.id.kode =:kode")
	@Cacheable("JenisRangeDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode,
			@Param("kdDepartemen") String kdDepartemen);

	String QListAll = "select new map(model.id.kdJenisRange as kdJenisRange,model.id.kdProfile as kdProfile " + ", model.namaJenisRange as namaJenisRange "
			+ ", model.reportDisplay as reportDisplay " + ", model.kdJenisRangeHead as kdJenisRangeHead "
			+ ", jenisRangeHead.namaJenisRange as namaJenisRangeHead " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal " + ", model.kdDepartemen as kdDepartemen "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec "
			+ ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from JenisRange model left join model.id id " + " left join model.jenisRangeHead jenisRangeHead "
			+ " left join model.departemen departemen left join model.profile profile "
			+ " where profile.kode =:kdProfile and model.kdDepartemen = :kdDepartemen ";
	
	@Query(QListAllForMasterSKKeterlambatan + " and model.id.kode =:kode")
	@Cacheable("JenisRangeDaoFindByKode")
	Map<String, Object> findByKodeKeterlambatan(@Param("kdProfile") Integer kdProfile, @Param("kode") Integer kode);
	
	String QListAllForMasterSKKeterlambatan = "select new map(model.id.kdJenisRange as kdJenisRange,model.id.kdProfile as kdProfile " + ", model.namaJenisRange as namaJenisRange "
			+ ", model.reportDisplay as reportDisplay " + ", model.kdJenisRangeHead as kdJenisRangeHead "
			+ ", jenisRangeHead.namaJenisRange as namaJenisRangeHead " + ", model.kodeExternal as kodeExternal "
			+ ", model.namaExternal as namaExternal " + ", model.kdDepartemen as kdDepartemen "
			+ ", model.statusEnabled as statusEnabled " + ", model.noRec as noRec "
			+ ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from JenisRange model left join model.id id " + " left join model.jenisRangeHead jenisRangeHead "
			+ " left join model.departemen departemen left join model.profile profile "
			+ " where profile.kode =:kdProfile ";
	
}
